<!--
Licensed Material - Property of IBM
5724-M24
(c) Copyright IBM Corp. 2005. All rights reserved.
US Government Users Restricted Rights - Use, duplication or
disclosure restricted by GSA ADP Schedule Contract with IBM Corp..
-->
<%--
History
Date mm/dd/yyyy   	ID              Comment
09/16/2005			swalter			Update copyright
06/20/2005			swalter			Update deprecated tag libs
06/13/2005			swalter			Add copyright
--%>

<%-- 

This file computes the appropriate URLs for the links that appear in the Actions menu. Due to a 
bug in the <wpsi:adminlinkinfo> tag concerning the navigation loop, the urls must be computed 
before the page navigation has been rendered.  The menu itself must be included at the bottom of
the page to avoid unnecessary whitespace at the top of the page.

--%>

<%
    	String newPageUrl = null;
    	String editPageUrl = null;
    	String permissionsPageUrl = null;
%>
<%-- New page --%>
	<wpsi:adminlinkinfo name="<%=AdminUniqueNamesMappingService.PROPERTIES_PORTLET%>">
		<wps:urlGeneration contentNode="<%=wpsContentNode%>"
					compositionNode='<%= wpsCompositionNode %>'
					portletWindowState="Solo" 
					pacCheck="<%=CreateUrlCommand.PAC_CREATE_PAGE%>">

					<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_INIT %>" value="init" />
					<wps:urlParam name="<%= SharedParamConstants.ORIGIN_CONTENT_NODE %>" value="<%= wpsContentNodeID %>" />
					<wps:urlParam name="<%= SharedParamConstants.WORKING_CONTENT_NODE%>" value="<%= wpsContentNodeID %>"/>
					<wps:urlParam name="<%= SharedParamConstants.PROPERTIES_ACTION_TYPE %>" value="<%= SharedParamConstants.PROPERTIES_ACTION_TYPE_QUICK_CREATE %>" />
					<wps:urlParam name="<%= SharedParamConstants.PROPERTIES_CONTENT_NODE_TYPE %>" value="<%= SharedParamConstants.PROPERTIES_CONTENT_NODE_TYPE_COMPOSITION %>" />
					<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_PUSH %>" value="push" />
					<% 
						java.io.StringWriter swNew = new java.io.StringWriter();
                        wpsURL.write(swNew);
                        newPageUrl = swNew.toString();
					%>
		</wps:urlGeneration>
	</wpsi:adminlinkinfo>
<%-- Edit page --%>
	<wpsi:adminlinkinfo name="<%=AdminUniqueNamesMappingService.CONTENT_LAYOUT%>">
		<%
			if (((ContentNodeType.COMPOSITION).toString()).equals(wpsContentNodeTypeString)) {
		%>
			<wps:urlGeneration contentNode="<%=wpsContentNode%>"
					portletWindowState="Normal"
					pacCheck="<%=CreateUrlCommand.PAC_EDIT_LAYOUT%>">

					<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_INIT %>" value="init" />
					<wps:urlParam name="<%= SharedParamConstants.WORKING_CONTENT_NODE%>" value="<%= wpsContentNodeID %>"/>
					<wps:urlParam name="<%= SharedParamConstants.ORIGIN_CONTENT_NODE %>" value="<%= wpsContentNodeID %>" />
					<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_PUSH %>" value="push" />
					<% 
						java.io.StringWriter swEdit1 = new java.io.StringWriter();
                        wpsURL.write(swEdit1);
                        editPageUrl = swEdit1.toString();
					%>
			</wps:urlGeneration>
		<%
			}
		%>
	</wpsi:adminlinkinfo>
	<wpsi:adminlinkinfo name="<%=AdminUniqueNamesMappingService.PROPERTIES_PORTLET%>">
		<%
			if (((ContentNodeType.LABEL).toString()).equals(wpsContentNodeTypeString)) {
		%>
			<wps:urlGeneration contentNode="<%=wpsContentNode%>"
						compositionNode='<%= wpsCompositionNode %>'
						portletWindowState="Solo"
						pacCheck="<%=CreateUrlCommand.PAC_EDIT_LAYOUT%>">

						<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_INIT %>" value="init" />
						<wps:urlParam name="<%= SharedParamConstants.ORIGIN_CONTENT_NODE %>" value="<%= wpsContentNodeID %>" />
						<wps:urlParam name="<%= SharedParamConstants.WORKING_CONTENT_NODE%>" value="<%= wpsContentNodeID %>"/>
						<wps:urlParam name="<%= SharedParamConstants.PROPERTIES_ACTION_TYPE %>" value="<%= SharedParamConstants.PROPERTIES_ACTION_TYPE_EDIT %>" />
						<wps:urlParam name="<%= SharedParamConstants.PROPERTIES_CONTENT_NODE_TYPE %>" value="<%= SharedParamConstants.PROPERTIES_CONTENT_NODE_TYPE_LABEL %>" />
						<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_PUSH %>" value="push" />
							<% 
								java.io.StringWriter swEdit2 = new java.io.StringWriter();
            		            wpsURL.write(swEdit2);
                    		    editPageUrl = swEdit2.toString();
							%>
			</wps:urlGeneration>
		<%
			}
		%>
	</wpsi:adminlinkinfo>
<%-- Assign permissions --%>
	<wpsi:adminlinkinfo name="<%=AdminUniqueNamesMappingService.ASSIGN_ROLES%>">
		<wps:urlGeneration contentNode="<%=wpsContentNode%>"
						compositionNode='<%= wpsCompositionNode %>'
						portletWindowState="Solo" pacCheck="<%=CreateUrlCommand.PAC_ASSIGN_ROLES%>">

						<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_INIT %>" value="init" />
						<wps:urlParam name="<%= SharedParamConstants.WORKING_CONTENT_NODE%>" value="<%= wpsContentNodeID %>"/>
						<wps:urlParam name="<%= SharedParamConstants.ORIGIN_CONTENT_NODE %>" value="<%= wpsContentNodeID %>" />
						<wps:urlParam name="<%= SharedParamConstants.WPS_ADMIN_NAVIGATION_PUSH %>" value="push" />
							<% 
								java.io.StringWriter swPermissions = new java.io.StringWriter();
            		            wpsURL.write(swPermissions);
                    		    permissionsPageUrl = swPermissions.toString();
							%>
		</wps:urlGeneration>
	</wpsi:adminlinkinfo>


