//***************************************************************
//Licensed Material - Property of IBM
//5724-M24
//(c) Copyright IBM Corp. 2005. All rights reserved.
//US Government Users Restricted Rights - Use, duplication or
//disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
//***************************************************************
//History
//Date MM-DD-YYYY          	ID                 	Comment
//09/16/2005				swalter				Update copyright
//06/13/2005				swalter				Add copyright

// onlinecenter.js
// 
// Used by the online center tag to display and allow changing of the online status of a user
//
// Author: Harry Hornreich, Assya Azrieli
// Modified by: Assya Azrieli 23/11/03
// Modified by: De Lion Daniel 28/1/04
/*
 * To use you must do similar to the following example 
 * ("uniquename" is the unique id of the online center):
 *
 * Execute the following JS
 * onlineCenterUsername = <username>;
 * onlineCenterToken = <token>;
 * onlineCenterImagePath = <imagesRootURL>);	// Optional
 * onlineCentersArray[<uniquename>] = new OnlineCenter();
 * TBD - change status command
 * 
 * Then add the following HTML
 * 			<A href='#' onClick="buildOnlineCenterMenu(true);">
 *			<IMG src='' alt='' width='16' height='16' border='0' align='absmiddle' 
 * 					id='<uniquename>_onlineCenterStatusIcon'>
 *			<SPAN id='<uniquename>_onlineCenterTagText'> </SPAN>
 *			</A>
 *
 * Then call the following JS
 * OnlineCentersRefresh();
 */

// Define all the following only once


function OnlineCenterPeopleLinksJoinNWayChatFailed()
{
	alert(onlineCenterJoinFailed);
}
//----------------------------------------------------------------------------------------------------------
//#function Name:	IMMessageStack
// Input parametrer:	chatWinURL,windowName
// Return parameter: 	
// Description:		This object service us to buferize the IM messages before the IM window become to be started
// Date:		28/1/2004
// Author:		Daniel DeLion
// Edited by:		
//---------------------------------------------------------------------------------------------------------
function IMMessageStack()
{
	var m_Counter = 0; //Reference counter
	this.m_MessageArray = new Array();

	this.Push = function(partnerEmail,txt )	
	{
		if (typeof this.m_MessageArray[partnerEmail] == "undefined") {
			this.m_MessageArray[partnerEmail] = new Array();
		}

		this.m_MessageArray[partnerEmail].push(txt);
	};
	
	this.Pop = function( partnerId )
	{
		var tmp = this.m_MessageArray[partnerId];
		if ( typeof( tmp ) != "undefined")
		{
			var winHndl = window.open("",EscapeWindowName("IM_" + partnerId));
			for (var i = 0 ; i < tmp.length ; i++)
			{
				if ( typeof( winHndl.winType ) == "string" )
				{
					if ( typeof( winHndl.IGotAMessage ) != "undefined")
					{
						if (tmp[i] !="")
							winHndl.IGotAMessage( partnerId ,tmp[i] );
					}
				}
			}
		}
		this.m_MessageArray[partnerId] = null;
		this.m_MessageArray[partnerId] = undefined;
	};
}

if ( typeof ( OnlineCenterIMMessageStack ) == "undefined" )
	OnlineCenterIMMessageStack = new IMMessageStack();
	
if (typeof onlineCentersArray == "undefined") {
	
	//Daniel's code
	OnlineCenterLoggedIn = false;
	//end of Daniel's code
	// All the following are global vars
	
	// Holds all the online center objects
	var onlineCentersArray = new Object;	

	// The following vars hold strings use by the online center
	// These strings should be overriden with strings according to locale
	var onlineCenterAvailable = "I am available";
	var onlineCenterAway = "I am away";
	var onlineCenterDND = "Do not disturb";
	var onlineCenterOffline = "Disconnected";
	var onlineCenterCustomizeStatus = "Customize status...";
	var onlineCenterLogOut = "Log out of instant messaging";
	var onlineCenterLogin = "Log in to instant messaging";
	var customizeStatusAvailableMsg = "I am available to chat";
	var customizeStatusAwayMsg = "I am away from my computer right now";
	var customizeStatusDNDMsg = "I am not available to chat";
		
	// Sametime status constants
	var PPL_ONLY_ONE_USER_AVAILABLE_TO_CHAT = 50001;
	var PPL_NO_USER_AVAILABLE_TO_CHAT = 50000;
	var stStatusOffline = 0;
	var stStatusActive = 32;
	var stStatusAutoAway = 64;
	var stStatusAway = 96;
	var stStatusDND = 128;
	
	// The user's online status and status message
	var onlineCenterUserStatus = stStatusOffline;	
	var onlineCenterUserStatusMsg = "";	
	var CustomizeStatusWindHandle = null;	
	// Remembers last tag text for drop down icon alt text
	var onlinecenterChatIdContainer = new Array();
	var onlineCenterLastTagText	= "";
	var OnlinecenterRecievedStatusMessage = "";
	// The user id returned in the logged in event
	var onlineCenterUserId = "";	

	// The following two vars should be overriden by the using application
	// with the real user's name and token so that he can login to IM
	var onlineCenterUsername = "";
	var onlineCenterToken = "";
	
	// Status images path 
	var onlineCenterImagePath = "/wps/images/icons";	
	
	// Change status command to be run when user selects change status
	var onlineCenterChangeStatusCmd = "";
	
	// Open Im window when user get NewIMReceived event.
	var onlineCenterChatHiddenPageURL = "";
	
	// Open ContactList portlet when 
	// "Add to contact List...","Remove..." or "Edit..." menu items of person tag were clicked
	var onlineCenterContactListCmd = "";
		
	// Counter used to create unique menus
	var onlineCenterCounter = 0;	
	
	
	var CustStatusWindIsOpen = false;
	// Set the PeopleLinks listeners
	if (typeof PeopleLinksAddListener == "function")
	{
		PeopleLinksAddListener("PeopleLinksLoggedIn", "OnlineCenterPeopleLinksLoggedIn");
		PeopleLinksAddListener("PeopleLinksLoggedOut", "OnlineCenterPeopleLinksLoggedOut");
		PeopleLinksAddListener("PeopleLinksMyStatusChanged", "OnlineCenterPeopleLinksMyStatusChanged");
		PeopleLinksAddListener("PeopleLinksNewIMReceived", "OnlineCenterPeopleLinksNewIMReceived");
		PeopleLinksAddListener("PeopleLinksInvitationReceived", "OnlineCenterPeopleLinksNewInvitationReceived");
		PeopleLinksAddListener("PeopleLinksNWayChatStarted", "OnlineCenterPeopleLinksNWayChatStarted");
		PeopleLinksAddListener("PeopleLinksStartNWayChatFailed", "OnlineCenterPeopleLinksStartNWayChatFailed");
		PeopleLinksAddListener("PeopleLinksNWayChatJoined", "OnlineCenterPeopleLinksPeopleLinksNWayChatJoined");
		PeopleLinksAddListener("PeopleLinksJoinNWayChatFailed", "OnlineCenterPeopleLinksJoinNWayChatFailed");
	}
	
	//Global variable for coockies

	var windowXSize=550;
	var windowYSize=375;
	var winTop,winLeft;

}



//----------------------------------------------------------------------------------------------------------
// function Name:	OnlineCenter_OpenCustomizeStatus
// Input parametrer:	
// Return parameter: 	
// Description:		This object service us to buferize the IM messages before the IM window become to be started
// Date:		28/1/2004
// Author:		Daniel DeLion
// Edited by:		
//---------------------------------------------------------------------------------------------------------

function OnlineCenter_OpenCustomizeStatus ()
{
	var CustomizeStatusUrl = onlineCenterChangeStatusCmd.split("'");
	var windowStr="fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=no,resizable=yes,directories=no,location=no,width=500,height=400,left=100,top=100";
	CustomizeStatusWindHandle = window.open(CustomizeStatusUrl[1],"Customize_Status_Dialog",windowStr);
	CustStatusWindIsOpen = true;

}


//----------------------------------------------------------------------------------------------------------
// function Name:	onfocus
// Input parametrer:	
// Return parameter: 	
// Description:		Overriding of window.onfocus function.
// Date:		28/3/2004
// Author:		Daniel DeLion
// Edited by:		
//---------------------------------------------------------------------------------------------------------

window.onfocus = function()
{
	
	try 
	{
		if (CustStatusWindIsOpen == true)
		{
		 	//if ( CustomizeStatusWindHandle.widndowIsFocused == false)	
				CustomizeStatusWindHandle.focus();
		}
	}
	catch(err){}
}

//
// Constructors
//

// Builds the OnlineCenter object
function OnlineCenter()
{
	// Currently empty on purpose
}

//
// Mouse events handlers
//

// Called when mouse is over online center
function OnMouseOverHandler(onlineCenterName)
{
	var alt_titleSt;
	if ( OnlinecenterRecievedStatusMessage != "" )
	{
		alt_titleSt = OnlinecenterRecievedStatusMessage;
	}
	else
	{
		alt_titleSt =onlineCenterLastTagText;
	}
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').src =  onlineCenterImagePath + "/MenuDropdown.gif";
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').alt = alt_titleSt;
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').title = alt_titleSt;
	document.getElementById(onlineCenterName + '_onlineCenterStatusIcon').alt = alt_titleSt;
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').title =	alt_titleSt;
		
}

// Called when mouse leaves online center
function OnMouseOutHandler(onlineCenterName)
{
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').src = onlineCenterImagePath + "/ClearPixel.gif";
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').alt = '';
	document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').title = '';
}

//
// Menu creation and callback handlers
//

// Creates the online center popup menu
function BuildOnlineCenterMenu(onlineCenterName, isLTR, target) 
{
	// Create the actual menu
	onlineCenterCounter = onlineCenterCounter + 1;
	var menu = createContextMenu(onlineCenterCounter, isLTR);

	// Menu depends on whether user is logged in or logged out 
	if (OnlineCenterIsUserLoggedIn()) 
	{	
		// I am available menu
		menu.add(new UilMenuItem(onlineCenterAvailable, 
				(OnlineCenterIsUserLoggedIn() && !OnlineCenterIsUserActive()), 
				'', 'OnOnlineCenterAvailable("' + onlineCenterName + '")', null, null, 
				OnlineCenterIsUserActive(), 'lwpMenuItem', 'lwpSelectedMenuItem')); 
		
		// I am away menu
		menu.add(new UilMenuItem(onlineCenterAway, 
				(OnlineCenterIsUserLoggedIn() && !OnlineCenterIsUserAway()),
				'', 'OnOnlineCenterAway("' + onlineCenterName + '")', 
				null, null, OnlineCenterIsUserAway(), 
				'lwpMenuItem', 'lwpSelectedMenuItem')); 
	
		// Do not disturb menu
		menu.add(new UilMenuItem(onlineCenterDND, 
				(OnlineCenterIsUserLoggedIn() && !OnlineCenterIsUserDND()),
				'', 'OnOnlineCenterDND("' + onlineCenterName + '")', 
				null, null, OnlineCenterIsUserDND(), 
				'lwpMenuItem', 'lwpSelectedMenuItem')); 
	
		// Create a seperator
		menu.addSeparator();
		
		// Customize status menu
		menu.add(new UilMenuItem(onlineCenterCustomizeStatus,
				OnlineCenterIsUserLoggedIn(), '', 
				'OnOnlineCenterCustomizeStatus("' + onlineCenterName + '")', 
				null, null, false, 'lwpMenuItem', 'lwpSelectedMenuItem')); 
	
		// Create a seperator
		menu.addSeparator();
	
		menu.add(new UilMenuItem(onlineCenterLogOut, true, '', 
		'OnOnlineCenterLogout("' + onlineCenterName + '")', null, null, false, 
		'lwpMenuItem', 'lwpSelectedMenuItem')); 
	}
	else // user is logged out
	{
		menu.add(new UilMenuItem(onlineCenterLogin, true, '',
		'OnOnlineCenterLogin("' + onlineCenterName + '")', null, null, false, 
		'lwpMenuItem', 'lwpSelectedMenuItem')); 
	}

	// Display the menu
 	return showContextMenu(onlineCenterCounter, target);
}

// "I Am Available" menu handler
function OnOnlineCenterAvailable(onlineCenterName)
{
	PeopleLinksChangeMyStatus(stStatusActive, customizeStatusAvailableMsg);
	
	// Set the focus back on the online center tag
	document.getElementById(onlineCenterName + '_onlineCenterAnchor').focus();
}

// "I Am Away" menu handler
function OnOnlineCenterAway(onlineCenterName)
{
	PeopleLinksChangeMyStatus(stStatusAway, customizeStatusAwayMsg);
	
	// Set the focus back on the online center tag
	document.getElementById(onlineCenterName + '_onlineCenterAnchor').focus();
}

// "Do Not Disturb" menu handler
function OnOnlineCenterDND(onlineCenterName)
{
	PeopleLinksChangeMyStatus(stStatusDND, customizeStatusDNDMsg);
	
	// Set the focus back on the online center tag
	document.getElementById(onlineCenterName + '_onlineCenterAnchor').focus();
}

// "Customize Status" menu handler
function OnOnlineCenterCustomizeStatus(onlineCenterName)
{
	// execute the stored change status command
	//eval(onlineCenterChangeStatusCmd);
	OnlineCenter_OpenCustomizeStatus();
}

// "Log On to Instant Messaging" menu handler
function OnOnlineCenterLogin(onlineCenterName)
{
	// Verify PeopleLinks is defined correctly (good for no email situation)
	if (typeof PeopleLinksEnableLogin == "function") {
	
		// Notify PeopleLinks to enable login
		PeopleLinksEnableLogin(true);
		
		// Request to login to IM based on the information set in the vars
		PeopleLinksLogin(onlineCenterUsername, onlineCenterToken);
		
		// Set the focus back on the online center tag
		document.getElementById(onlineCenterName + '_onlineCenterAnchor').focus();
	}
}

// "Log Out of Instant Messaging" menu handler
function OnOnlineCenterLogout(onlineCenterName)
{
	// Request to logout of IM
	//PeopleLinksChangeMyStatus(0,"Offline");
	PeopleLinksLogout();
	
	// Notify PeopleLinks to prevent login so that you do not automaticaly login 
	// when navigating pages
	PeopleLinksEnableLogin(false);
	
	// Set the focus back on the online center tag
	document.getElementById(onlineCenterName + '_onlineCenterAnchor').focus();
}

// Custmize Status dialog callback
function OnCustmizeStatusDialog(status)
{
	
	PeopleLinksChangeMyStatus(status[0], status[1]);
}


//
// PeopleLinks event handlers
//

// PeopleLinks logged in event handler
function OnlineCenterPeopleLinksLoggedIn(myId)
{
	// Remember my user id
	onlineCenterUserId = myId;		
	
	// Set user's status as active by default with default status message
	onlineCenterUserStatus = stStatusActive;
	onlineCenterUserStatusMsg = onlineCenterAvailable;
	
	// Refresh all online centers with new status
	//OnlineCentersRefresh();
	
	OnlineCenterLoggedIn = true;
}

// PeopleLinks logged out event handler
function OnlineCenterPeopleLinksLoggedOut(userId, reason )
{
	// Verify this loggedOut event is related to this user
	if(userId==onlineCenterUserId)
	{		
		// Set status as logged out including status message
		onlineCenterUserStatus = stStatusOffline;
		onlineCenterUserStatusMsg = onlineCenterOffline;
		
		// Refresh all online centers with new status
		OnlineCentersRefresh();
	}
}

// PeopleLinks user status changed event handler
function OnlineCenterPeopleLinksMyStatusChanged(status, statusMsg)
{
	
	// Update the user's status and status message
	onlineCenterUserStatus = status;	
	onlineCenterUserStatusMsg = statusMsg;
	OnlinecenterRecievedStatusMessage = statusMsg;
	//onlineCenterLastTagText = statusMsg;
	// Refresh all online centers with new status
	OnlineCentersRefresh();
}

//
// Helper Methods
//

// Returns true only if user is currently logged in
function OnlineCenterIsUserLoggedIn()
{
	return (onlineCenterUserStatus != stStatusOffline);
}

// Returns true only if user is currently with Active status
function OnlineCenterIsUserActive()
{
	return (onlineCenterUserStatus == stStatusActive);
}

// Returns true only if user is currently with Away or Auto Away status
function OnlineCenterIsUserAway()
{
	return ((onlineCenterUserStatus == stStatusAutoAway) ||
			(onlineCenterUserStatus == stStatusAway));
}

// Returns true only if user is currently with DND status
function OnlineCenterIsUserDND()
{
	return (onlineCenterUserStatus == stStatusDND);
}

// Refreshes all the online centers on the page with the latest user status
// and user status message
function OnlineCentersRefresh()
{
	// Figure out what status image and tag text need to be displayed 
	var statusImageURL = "";
	if (!OnlineCenterIsUserLoggedIn())
	{
		statusImageURL = onlineCenterImagePath + "/ClearPixel.gif";
		onlineCenterLastTagText = onlineCenterOffline;
	}
	
	if (OnlineCenterIsUserActive())
	{
		statusImageURL = onlineCenterImagePath + "/StatusActive.gif";
		onlineCenterLastTagText = onlineCenterAvailable;
	}
	
	if (OnlineCenterIsUserAway())
	{
		statusImageURL = onlineCenterImagePath + "/StatusAway.gif";
		onlineCenterLastTagText = onlineCenterAway;
	}
	
	if (OnlineCenterIsUserDND())
	{
		statusImageURL = onlineCenterImagePath + "/StatusDoNotDisturb.gif";
		onlineCenterLastTagText = onlineCenterDND;
	}

	// For each online center tag
	for (var onlineCenterName in onlineCentersArray) 
	{	
		// Update the icon and text of each online center tag
		document.getElementById(onlineCenterName + '_onlineCenterStatusIcon').src = statusImageURL;
		var alt_titleSt;
		if ( OnlinecenterRecievedStatusMessage != "" )
		{
			alt_titleSt = OnlinecenterRecievedStatusMessage;
		}
		else
		{
			alt_titleSt =onlineCenterLastTagText;
		}
			
		document.getElementById(onlineCenterName + '_onlineCenterStatusIcon').alt = alt_titleSt;
		document.getElementById(onlineCenterName + '_onlineCenterStatusIcon').title = alt_titleSt;
		document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').alt = alt_titleSt;
		document.getElementById(onlineCenterName + '_onlineCenterDropDownIcon').title = alt_titleSt;
		
		document.getElementById(onlineCenterName + '_onlineCenterTagText').innerHTML = onlineCenterLastTagText;
		document.getElementById(onlineCenterName + '_onlineCenterTagText').alt = alt_titleSt;
		document.getElementById(onlineCenterName + '_onlineCenterTagText').title = alt_titleSt;
	}
}


function getCookieVal(offset){
	var endstr=document.cookie.indexOf(";",offset);
    if(endstr==-1)
        endstr=document.cookie.length;
    return unescape(document.cookie.substring(offset, endstr));
}

function FixCookieDate(date){
	var base=new Date(0);
    var skew=base.getTime(); 
	if(skew>0) 
        date.setTime(date.getTime() - skew);
}

function GetCookie(name){
	var arg=name+"=",
        alen=arg.length,
        clen=document.cookie.length,
        i=0;
	while(i<clen){
        var j=i+alen;
        if(document.cookie.substring(i,j)==arg)return getCookieVal(j);
		i=document.cookie.indexOf(" ",i)+1;
		if(i==0)break;
	}
	return null;
}

function SetCookie(name,value,expires,path,domain,secure){
    document.cookie=name+"="+escape(value)+
        ((expires)?"; expires="+expires.toGMTString():"")+
		((path)?"; path=" + path:"")+
		((domain)?"; domain="+domain:"")+
		((secure)?"; secure":"");
}

function DeleteCookie(name,path,domain){
    if(GetCookie(name)){
        document.cookie=name+"="+
			((path)?"; path="+path:"")+
			((domain)?"; domain="+domain:"")+
			"; expires=Thu, 01-Jan-70 00:00:01 GMT";
	}
}

function getNewTop(oldTop)
{
	var newTop = parseInt(oldTop) + 40;
	
	if( (newTop + windowYSize ) >= screen.height )
		return 0;
	
	else return newTop;
}


function getNewLeft(oldLeft)
{
	var newLeft = parseInt(oldLeft) + 40;
	
	if( ( newLeft + windowXSize ) >= screen.width )
			return 0;
	
	else return newLeft;
}

//----------------------------------------------------------------------------------------------------------
//#function Name:	replaceSubstring
// Input parametrer:	inputString, fromString, toString
// Return parameter: 	updated input string
// Description:		Function removes illegal charackters, not like escape
// Date:		28/1/2004
// Author:		Daniel DeLion
// Edited by:
//---------------------------------------------------------------------------------------------------------
function replaceSubstring(inputString, fromString, toString) {
   // Goes through the inputString and replaces every occurrence of fromString with toString
   var temp = inputString;
   if (fromString == "") {
      return inputString;
   }
   if (toString.indexOf(fromString) == -1) { // If the string being replaced is not a part of the replacement string (normal situation)
      while (temp.indexOf(fromString) != -1) {
         var toTheLeft = temp.substring(0, temp.indexOf(fromString));
         var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);
         temp = toTheLeft + toString + toTheRight;
      }
   } else { // String being replaced is part of replacement string (like "+" being replaced with "++") - prevent an infinite loop
      var midStrings = new Array("~", "`", "_", "^", "#");
      var midStringLen = 1;
      var midString = "";
      // Find a string that doesn't exist in the inputString to be used
      // as an "inbetween" string
      while (midString == "") {
         for (var i=0; i < midStrings.length; i++) {
            var tempMidString = "";
            for (var j=0; j < midStringLen; j++) { tempMidString += midStrings[i]; }
            if (fromString.indexOf(tempMidString) == -1) {
               midString = tempMidString;
               i = midStrings.length + 1;
            }
         }
      } // Keep on going until we build an "inbetween" string that doesn't exist
      // Now go through and do two replaces - first, replace the "fromString" with the "inbetween" string
      while (temp.indexOf(fromString) != -1) {
         var toTheLeft = temp.substring(0, temp.indexOf(fromString));
         var toTheRight = temp.substring(temp.indexOf(fromString)+fromString.length, temp.length);
         temp = toTheLeft + midString + toTheRight;
      }
      // Next, replace the "inbetween" string with the "toString"
      while (temp.indexOf(midString) != -1) {
         var toTheLeft = temp.substring(0, temp.indexOf(midString));
         var toTheRight = temp.substring(temp.indexOf(midString)+midString.length, temp.length);
         temp = toTheLeft + toString + toTheRight;
      }
   } // Ends the check to see if the string being replaced is part of the replacement string or not
   return temp; // Send the updated string back to the user
} // Ends the "replaceSubstring" function

//----------------------------------------------------------------------------------------------------------
//#function Name:	EscapeWindowName
// Input parametrer:	str
// Return parameter: 	updated str
// Description:		
// Date:		28/1/2004
// Author:		Daniel DeLion
// Edited by:
//---------------------------------------------------------------------------------------------------------
function EscapeWindowName(str)
{
	str =replaceSubstring(str,"@","_");
	str =replaceSubstring(str,".","_");
	str =replaceSubstring(str,"'","_");
	str =replaceSubstring(str,"'","_");
	str =replaceSubstring(str," ","_");
	return str;
}
//----------------------------------------------------------------------------------------------------------
//#function Name:	OnlineCenterOpenChatPortlet
// Input parametrer:	chatWinURL,windowName
// Return parameter: 	
// Description:		
// Date:		28/1/2004
// Author:		Assya Azriely, Shiri Lupovich
// Edited by:		Daniel DeLion
//---------------------------------------------------------------------------------------------------------

function OnlineCenterOpenChatPortlet(chatWinURL,windowName,fromStr,winType)
{
	var windowStr;
	
	//Window Position
	winTop=GetCookie("top");
	winLeft =GetCookie("left")
	
	if (winTop == null)
		winTop=0;
			
	if (winLeft == null)
		winLeft=0;
	
	winTop = parseInt(getNewTop(winTop));
	winLeft = parseInt(getNewLeft(winLeft));
	
	var str="top=" + winTop + ",left=" + winLeft + ",width=" + windowXSize + ",height=" + windowYSize;
	
	if (winType == "INVITATION")
		 windowStr="fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=yes,resizable=yes,directories=no,location=no,width=400,height=150,left=" + winLeft + ",top=" + winTop;
	else
		windowStr="fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=no,resizable=yes,directories=no,location=no,width=" + windowXSize + ",height=" + windowYSize + ",left=" + winLeft + ",top=" + winTop;
		
	var winHndl = window.open("",windowName,windowStr);
	
	
	if ( winHndl == null  || typeof( winHndl.winType ) != "string" ) //check if window is already open
	{
		
		window.open( chatWinURL, windowName , windowStr );
	}
	else
	{
		winHndl.focus();
	}
	
	//end of Daniel's code
	DeleteCookie("left", winLeft);
	DeleteCookie("top", winTop);
	SetCookie("left", winLeft);
	SetCookie("top", winTop);
}

function OnlineCenterOpenNewIMWindow(userId, partnerId, text)
{
	/* ToDo: need to handle: */
	/* 1)Am I DND? */
	/* 2)window alreay open with same user */
	var chatWinURL = onlineCenterChatHiddenPageURL +
		"?winType=IM"+ "&userId="+ userId +
		"&partnerId="+ partnerId + "&text=" + text + 
		"&ChatTime=" +  GetTime();
			
	OnlineCenterOpenChatPortlet(chatWinURL, EscapeWindowName("IM_" + partnerId), "OnlineCenterOpenNewIMWindow","IM" );

}

function OnlineCenterOpenNewInvitationWindow(userId, chatId, inviterEmail, topic, inviteText)
{
	//ToDo - handle DND, window pos
	var chatWinURL = onlineCenterChatHiddenPageURL +
		"?winType=INVITATION"+
		"&userId="+ userId +
		"&chatId="+ chatId +
		"&partnerId="+ inviterEmail +
		"&topic="+ topic +
		"&inviteText=" + inviteText;
		
	OnlineCenterOpenChatPortlet(chatWinURL, EscapeWindowName("NWay_" + chatId),"OnlineCenterOpenNewInvitationWindow","INVITATION");
}

// "PeopleLinksNewIMReceived" event handler
function OnlineCenterPeopleLinksNewIMReceived( partnerId, text )
{
	if ( (onlineCenterUserStatus != stStatusDND ) && ( onlineCenterUserStatus != stStatusOffline) )
	{
		OnlineCenterIMMessageStack.Push( partnerId,text);
		setTimeout("OnlineCenterOpenNewIMWindow(onlineCenterUserId,\""+ partnerId + "\",\"true\")",10);
	}
}


function OnlineCenterPeopleLinksNewIMFromPersonTag( partnerId, text )
{
	setTimeout("OnlineCenterOpenNewIMWindow(onlineCenterUserId,\""+ partnerId + "\",'')",10);
}



// "PeopleLinksInvitationReceived" event handler
function OnlineCenterPeopleLinksNewInvitationReceived(chatId, inviterEmail, topic, inviteText)
{
	if ( (onlineCenterUserStatus != stStatusDND ) && ( onlineCenterUserStatus != stStatusOffline) )
	{
		// execute the stored NewIMReceived command
		OnlineCenterOpenNewInvitationWindow(onlineCenterUserId, chatId, inviterEmail, topic, inviteText);	
		onlinecenterChatIdContainer[chatId] = inviterEmail;
	}
}



function OnlineCenterPeopleLinksPeopleLinksNWayChatJoined(chatId)
{
	OnlineCenterPeopleLinksNWayChatStarted(chatId, 0, 0);
}


function GetTime()
{
	tmpDate = new Date();
	str = tmpDate.toLocaleTimeString();
	var timeStr = str.split(' ');
	var delimeter = timeStr[0].charAt(timeStr[0].length-3);
	var hours_minutes = timeStr[0].split(delimeter);
	resultStr = hours_minutes[0] + delimeter + hours_minutes[1] + " " + timeStr[1];
	return resultStr;
}


/*-------------------------------------------------------------------------------------------------*/
/* OnlineCenterPeopleLinksNWayChatStarted                                                          */
/*                                                                                                 */
/* "PeopleLinksNWayChatStarted" event handler. This event is sent only to the Nway initiator who   */
/* called the method OnlineCenterOpenNewNWayWindow.                                                */
/*                                                                                                 */
/* Params:                                                                                         */
/* chatId -                                        						   */
/* offlineUsersCounter -                                                                           */
/* dndUsersCounter -                                                                               */
/*                                                                                                 */
/*                                                                                                 */
/* Shiri Lupovich, Dec 2003                                                                        */
/*-------------------------------------------------------------------------------------------------*/
function OnlineCenterPeopleLinksNWayChatStarted(chatId, offlineUsersCounter, dndUsersCounter)
{

	/* if there are any offline or dnd users we need to show a popup message */
	if (offlineUsersCounter>0 || dndUsersCounter>0)
	{
		if (typeof (onlineCenterSomeUsersDNDOrOfflineMsg) != "undefined")
			alert(onlineCenterSomeUsersDNDOrOfflineMsg);
	}
	
	/* open the chat window with a new Nway Chat */
	
	var invitorId = onlineCenterUserId ;
	if (onlinecenterChatIdContainer[chatId] != null && typeof(onlinecenterChatIdContainer[chatId]) != "undefined" )
	{
		invitorId = onlinecenterChatIdContainer[chatId];
	}
	
	var chatWinURL = onlineCenterChatHiddenPageURL +
		"?winType=NWAY&invitorId=" + invitorId + "&userId=" + onlineCenterUserId + "&userName="  + onlineCenterUsername + "&chatId=" + chatId + "&ChatTime=" +  GetTime();
		
	OnlineCenterOpenChatPortlet(chatWinURL, EscapeWindowName("NWay_" + chatId),"OnlineCenterPeopleLinksNWayChatStarted","NWAY");
}

/*-------------------------------------------------------------------------------------------------*/
/* OnlineCenterPeopleLinksStartNWayChatFailed                                                          */
/*                                                                                                 */
/* "PeopleLinksStartNWayChatFailed" event handler. This event is sent only to the Nway initiator   */
/* who called the method OnlineCenterOpenNewNWayWindow.                                            */
/* Reason for failure can be that all users are offline or dnd or that only one user is available  */
/* to chat. In this case we start an IM with this user.                                            */
/*                                                                                                 */
/* Params:                                                                                         */
/* reason -                                        */
/* onlineInvitee -                                                                                   */
/*                                                                                                 */
/* Shiri Lupovich, Dec 2003                                                                        */
/* Delion Daniel, Apr 2004                                                                        */
/*-------------------------------------------------------------------------------------------------*/
function OnlineCenterPeopleLinksStartNWayChatFailed(reason, onlineInvitee)
{
	if (parseInt(reason) == PPL_ONLY_ONE_USER_AVAILABLE_TO_CHAT)
	{
		str = onlineInvitee.split(";");
		OnlineCenterOpenNewIMWindow(onlineCenterUserId, str[0],"");
	}
	else if (parseInt(reason) == PPL_NO_USER_AVAILABLE_TO_CHAT)
	{
		if (typeof (onlineCenterNoUserAvailableToChatMsg) != "undefined")
			alert("" + onlineCenterNoUserAvailableToChatMsg);
	}
}


/*-------------------------------------------------------------------------------------------------*/
/* OnlineCenterOpenNewNWayWindow                                                                   */
/*                                                                                                 */
/* Called by the ContactList portlet when user presses "start a chat".                             */
/*                                                                                                 */
/* Params:                                                                                         */
/* invitees -   list of invitees emails separated by semicolon                                     */
/* topic -      string                                                                             */
/* inviteText - string                                                                             */
/*                                                                                                 */
/* Shiri Lupovich, Dec 2003                                                                        */
/*-------------------------------------------------------------------------------------------------*/
function OnlineCenterOpenNewNWayWindow(invitees, topic, inviteText)
{
	/* we try to start a new NWay with the list of users */
	/* if some are offline or dnd we will get event PeopleLinksNWayChatStarted with the number of offline and dnd users */
	/* if all are offline or dnd we will get event PeopleLinksStartNWayChatFailed with reason that all are offline or dnd */
	/* if only one user is available to chat we will get event PeopleLinksStartNWayChatFailed with email of that person */
	PeopleLinksStartNWayChat(invitees, topic, inviteText);
}

function OnlineCenterOpenAddToContactList(userId, groupId)
{
	var addToContWinURL = onlineCenterContactListCmd +
		"?winType=OnlineCenterAddMenu"+
		"&userId="+ userId +
		"&groupId="+ groupId;
	
	/* TODO: need to open the window at the center of the screen and at right size */
	var windowStr="fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=no,resizable=yes,directories=no,location=no,width=" + windowXSize + ",height=" + windowYSize + ",left=" + winLeft + ",top=" + winTop;

	window.open(addToContWinURL, "",windowStr);
}

function OnlineCenterOpenRemove(userId, groupId, confirmMessage)
{
	var removeWinURL = onlineCenterContactListCmd +
		"?winType=OnlineCenterRemoveMenu"+
		"&userId="+ userId +
		"&groupId="+ groupId +
		"&confirmMessage="+ confirmMessage;
	
	/* TODO: need to open the window at the center of the screen and at right size */
	var windowStr="fullscreen=no,toolbar=no,status=no,menubar=no,scrollbars=no,resizable=no,directories=no,location=no,width=" + windowXSize + ",height=100,left=100,top=200";
	window.open(removeWinURL, "",windowStr);
}

function OnlineCenterOpenEdit(userId, groupId)
{
	alert("Edit Contact action replacer");
}
