@rem ************************************************************************
@rem  Licensed Material - Property of IBM
@rem 
@rem  5724-M24 
@rem 
@rem  (c) Copyright IBM Corp. 2006.  All rights reserved.
@rem 
@rem  US Government Users Restricted Rights - Use, duplication or
@rem  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@rem ************************************************************************

@rem ************************************************************************
@rem  Upgrade Monitor 6.0.0 to 6.0.1
@rem ***********************************************************
@echo off
setlocal
REM set defaults 
for /F %%i IN ('time /t') DO set START_TIME=%%i 
for /F %%i IN ('cd') DO set MY_DIR=%%i

set MY_DRIVE=C:
set LOGS=%MY_DIR%\install\logs
set COPYFILES_OUT=%LOGS%\copy_Files.out
set PROFILE_NAME=dashboard
set WAS_HOME=%MY_DRIVE%\IBM\WebSphere\AppServer
set WPS_HOME=%MY_DRIVE%\IBM\WebSphere\PortalServer
set PROFILE_HOME=%MY_DRIVE%\IBM\WebSphere\AppServer\profiles\%PROFILE_NAME%
for /F %%i IN ('hostname') DO set CELL_NAME=%%iNode01Cell
set NODE=Node01
set PORTAL_SERVER=WebSphere_Portal
set ADMIN_ID=wpsadmin
set ADMIN_PW=wpsadmin
set CONFIG_HOST=localhost
set CONFIG_PORT=9081
set ABX_HOME=%MY_DRIVE%\IBM\Db2Alphablox
set ABX_HOST=localhost
set ABX_TELNET_PORT=23
set ABX_ADMIN_ID=admin
set ABX_ADMIN_PW=password
set ABX_THEME=wbmonitor
set SET_ABX_DEFAULT_THEME=yes
set SET_WPS_DEFAULT_THEME=yes
set WELCOME_PAGE=no
set CONFIG_URL=http://%CONFIG_HOST%:%CONFIG_PORT%/wps/config

REM goto skipPrompt

set PROFILE_PROMPT=Type the path to the WebSphere profile that the contains the Portal Server
set PORTAL_HOME_PROMPT=Type the path to the Portal Server installation directory
set WAS_HOME_PROMPT=Type the path to the WebSphere Server installation directory
set ABX_HOME_PROMPT=Type the path to the DB2 AlphaBlox installation directory
set CELL_PROMPT=Type the WebSphere cell name that contains the WebSphere Portal node
set CONFIG_PORT_PROMPT=Type the port number used to access the WebSphere Portal configuration utility 
set WPS_PW_PROMPT=Type the password for the Portal Admin user 
set ABX_PW_PROMPT=Type the password for the DB2 Alphablox Admin user 

REM get was variables
set /p RESPONSE=%WAS_HOME_PROMPT% [enter=%WAS_HOME%]: 
if not (%RESPONSE%) == () set WAS_HOME=%RESPONSE%
if not exist %WAS_HOME% goto badWasHome
set /p PROFILE_PROMPT_RESPONSE=%PROFILE_PROMPT% [enter=%PROFILE_HOME%]:
if not (%PROFILE_PROMPT_RESPONSE%) == () set PROFILE_HOME=%PROFILE_PROMPT_RESPONSE%
if not exist %PROFILE_HOME% goto badProfileHome

REM get portal variables
set /p RESPONSE=%PORTAL_HOME_PROMPT% [enter=%WPS_HOME%]:
if not (%RESPONSE%) == () set WPS_HOME=%RESPONSE%
if not exist %WPS_HOME% goto badPortalHome
set /p RESPONSE=%WPS_PW_PROMPT% [enter=%ADMIN_PW%]:
if not (%RESPONSE%) == () set ADMIN_PW=%RESPONSE%
set /p RESPONSE=%CELL_PROMPT% [enter=%CELL_NAME%]:
if not (%RESPONSE%) == () set CELL_NAME=%RESPONSE%


REM get alaphablox variables
set /p RESPONSE=%ABX_HOME_PROMPT% [enter=%ABX_HOME%]:
if not (%RESPONSE%) == () set ABX_HOME=%RESPONSE%
if not exist %ABX_HOME% goto badAbxThemeHome
set /p RESPONSE=%ABX_PW_PROMPT% [enter=%ABX_ADMIN_PW%]:
if not (%RESPONSE%) == () set ABX_ADMIN_PW=%RESPONSE%

:skipPrompt

REM need to set up logs directory
if not exist %MY_DIR%\install goto mkInstallDir
rmdir /S /Q %MY_DIR%\install
:mkInstallDir
mkdir %LOGS%

set ABX_THEME_HOME=%ABX_HOME%\repository\theme

echo backup %PROFILE_NAME% WAS configuration...
set CMD=%PROFILE_HOME%\bin\backupconfig -profileName %PROFILE_NAME% -username %ADMIN_ID% -password %ADMIN_PW%
call %CMD% >%LOGS%\backupconfig.log 2>&1 
if %errorlevel% GEQ 1 goto cmdFailed
echo Copying files...
set CMD=XCopy /F /R /Y files\dashboardclient.war "%WPS_HOME%\installableApps" 
%CMD% >%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
set CMD=XCopy /F /R /Y "jars\*.*" "%WAS_HOME%\lib"
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
set CMD=XCopy /F /R /Y "files\MON.product" "%WAS_HOME%\properties\version" 
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
REM ...copy our Alphablox theme files to Alphablox
set CMD=XCopy /F /R /Y /I /S "themes\wbmonitor\*" "%ABX_THEME_HOME%\wbmonitor" 
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
REM ...copy portal shared nls files
set CMD=XCopy /F /R /Y /I /S themes\nls\* "%WPS_HOME%\shared\app\nls" 
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
REM ...copy the built dashboard war files to the cell?
set CMD=XCopy /F /R /Y /I /S "themes\war\*" "%PROFILE_HOME%\installedApps\%CELL_NAME%\wps.ear\wps.war" 
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
REM ...copy the wbi mon .gif files to abx theme directory 
set ABX_THEME_HOME=%ABX_HOME%\repository\theme
set CMD=XCopy /F /R /Y /I /S "%ABX_THEME_HOME%\wbmonitor\i\brand.gif" "%ABX_THEME_HOME%\i\brand.gif"
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
set CMD=XCopy /F /R /Y /I /S "%ABX_THEME_HOME%\wbmonitor\i\logo.gif" "%ABX_THEME_HOME%\..\..\system\AlphabloxPlatform\AlphabloxServer\images\logo.gif" 
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed


echo starting server %PORTAL_SERVER%...
set CMD=%PROFILE_HOME%\bin\startServer.bat %PORTAL_SERVER% -username %ADMIN_ID% -password %ADMIN_PW%
call %CMD% >%LOGS%\startServer.log 2>&1 
if %errorlevel% NEQ 0 goto cmdFailed


echo deploying WBIMon...
set CMD="%WPS_HOME%\bin\xmlaccess" -in "scripts\update_WBIMon.xml" -user %ADMIN_ID% -pwd %ADMIN_PW% -url %CONFIG_URL% 
call %CMD% >%LOGS%\update_WBIMon.out 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

REM deploy theme
echo deploying Theme...
set CMD="%WPS_HOME%\bin\xmlaccess" -in "scripts\Deploy_Theme.xml" -user %ADMIN_ID% -pwd %ADMIN_PW% -url %CONFIG_URL% 
call %CMD% >%LOGS%\Deploy_Theme.out 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

if NOT "%SET_WPS_DEFAULT_THEME%" == "yes" goto skipPortalTheme
echo updating Theme...
set CMD=%WPS_HOME%\bin\xmlaccess -in "scripts\Set_WPSTheme.xml" -user %ADMIN_ID% -pwd %ADMIN_PW% -url %CONFIG_URL% 
call %CMD% >%LOGS%\Set_WPSTheme.out 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
:skipPortalTheme

if NOT "%SET_ABX_DEFAULT_THEME%" == "yes" goto skipAbxTheme
echo set alphablox theme...
set CMD=%WAS_HOME%\java\bin\java -classpath files\dashboardtheme.jar com.ibm.wbimonitor.dashboard.theme.SetABXTheme %ABX_HOST% %ABX_TELNET_PORT% %ABX_ADMIN_ID% %ABX_ADMIN_PW% %ABX_THEME% %MY_DIR% 
%CMD% >%LOGS%\Set_abxTheme.out 2>&1
echo setAbxTheme returned: %errorlevel% >>%LOGS%\Set_abxTheme.out
REM this seems to return 1 
REM if %errorlevel% EQU -1 goto cmdFailed
if NOT EXIST "%ABX_THEME_HOME%\pdfreportBACKUP.properties" set CMD=Copy  /Y "%ABX_THEME_HOME%\pdfreport.properties" "%ABX_THEME_HOME%\pdfreportBACKUP.properties"
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
set CMD=Copy /Y "%ABX_THEME_HOME%\wbmonitor\pdfreport.properties" "%ABX_THEME_HOME%\pdfreport.properties"
%CMD% >>%COPYFILES_OUT% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
:skipAbxTheme

echo updating WelcomePage...
set CMD=%WPS_HOME%\bin\xmlaccess -in "scripts\SetWelcomePage.xml" -user %ADMIN_ID% -pwd %ADMIN_PW% -url %CONFIG_URL% 
call %CMD% >%LOGS%\SetWelcomePage.out 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

echo stopping server %PORTAL_SERVER%...
set CMD=%PROFILE_HOME%\bin\stopServer.bat %PORTAL_SERVER% -username %ADMIN_ID% -password %ADMIN_PW%
call %CMD% >%LOGS%\stopServer.log 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

goto done



REM error messages start here
:badProfileHome
echo error: "%PROFILE_HOME%" does not exist
goto fatal
:badWasHome
echo error: "%WAS_HOME%" does not exist
goto fatal
:badPortalHome
echo error: "%WPS_HOME%" does not exist
goto fatal
:badAbxThemeHome
echo error: "%ABX_HOME%" does not exist
:cmdFailed
echo error: '%CMD%' returned %errorlevel%
goto fatal


:fatal
set errorlevel=8
goto done
:warning 
set errorlevel=4
goto done

:done
for /F %%i IN ('time /t') DO set END_TIME=%%i 
echo BEGIN: %START_TIME%
echo END:   %END_TIME%

endlocal
