@rem ************************************************************************
@rem  Licensed Material - Property of IBM
@rem 
@rem  5724-M24 
@rem 
@rem  (c) Copyright IBM Corp. 2006.  All rights reserved.
@rem 
@rem  US Government Users Restricted Rights - Use, duplication or
@rem  disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@rem ************************************************************************

@rem ************************************************************************
@rem  Upgrade Monitor Server 6.0.0 to 6.0.1
@rem ************************************************************************

@echo off
setlocal
set SAVE_RC=0
@rem set up logs directory
for /F %%i IN ('cd') DO set MY_DIR=%%i
if exist %MY_DIR%\logs goto setlog 
mkdir %MY_DIR%\logs
:setlog
set MY_LOG=%MY_DIR%\logs\monsrv.log

echo Start upgrade...
echo Start upgrade... >%MY_LOG%
time /t >>%MY_LOG%

@rem get WAS home dir       
set WAS_HOME=C:\IBM\WebSphere\ProcServer
set INPUT=
set /p INPUT=Type the Process Server home directory [enter=%WAS_HOME%]: 
IF NOT "%INPUT%"=="" set WAS_HOME=%INPUT%
if exist %WAS_HOME% goto getprof
echo %WAS_HOME% does not exist
call :logecho "%WAS_HOME% does not exist"
goto getout

@rem get profile dir       
:getprof
set WAS_PROFILE_HOME=C:\IBM\WebSphere\ProcServer\profiles\monitor
set INPUT=
set /p INPUT=Type the Process Server profile directory [enter=%WAS_PROFILE_HOME%]: 
IF NOT "%INPUT%"=="" set WAS_PROFILE_HOME=%INPUT%
if exist %WAS_PROFILE_HOME% goto getcell 
echo %WAS_PROFILE_HOME% does not exist
call :logecho "%WAS_PROFILE_HOME% does not exist"
goto getout

@rem get cell name       
:getcell
for /F %%v in ('hostname') do set cellName=%%v
set cellName=%cellName%Node01Cell
set INPUT=
set /p INPUT=Type the cell name [enter=%cellName%]: 
IF NOT "%INPUT%"=="" set cellName=%INPUT%
if exist %WAS_PROFILE_HOME%\config\cells\%cellName% goto getnode 
echo %WAS_PROFILE_HOME%\config\cells\%cellName% does not exist
call :logecho "%WAS_PROFILE_HOME%\config\cells\%cellName% does not exist"
goto getout
 
@rem get node name       
:getnode      
set nodeName=Node01
set INPUT=
set /p INPUT=Type the node name [enter=%nodeName%]: 
IF NOT "%INPUT%"=="" set nodeName=%INPUT%
if exist %WAS_PROFILE_HOME%\config\cells\%cellName%\nodes\%nodeName% goto setup 
echo %WAS_PROFILE_HOME%\config\cells\%cellName%\nodes\%nodeName% does not exist
call :logecho "%WAS_PROFILE_HOME%\config\cells\%cellName%\nodes\%nodeName% does not exist"
goto getout

@rem *********************************************************
@rem copy jar files      
@rem *********************************************************
:setup 
call "%WAS_PROFILE_HOME%\bin\setupCmdLine.bat" >>%MY_LOG% 2>&1

echo Stop server server1 ...
call :logecho "Stop server server1 ..."
call "%WAS_PROFILE_HOME%\bin\stopServer" server1 >>%MY_LOG% 2>&1

echo Copy jar files ...
call :logecho "Copy jar files ..."
copy .\jars\*.jar %WAS_HOME%\lib\ >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

copy .\files\MON.product %WAS_HOME%\properties\version\ >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

@rem ************************************************************************
@rem update enterprise applications
@rem can't use 'update <appName> app' because we'll lose the imported models
@rem ************************************************************************
echo Update Monitor Server application ...
call :logecho "Update Monitor Server application ..."
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_MONITOR_SERVER file {-operation update -contents %CD%\earfiles\adminservices.jar -contenturi adminservices.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_MONITOR_SERVER file {-operation update -contents %CD%\jars\bom.jar -contenturi bom.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_MONITOR_SERVER file {-operation update -contents %CD%\jars\DDbE.jar -contenturi DDbE.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_MONITOR_SERVER file {-operation update -contents %CD%\earfiles\eventrouter.jar -contenturi eventrouter.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
@rem use 'update <appName> modulefile' because we need to generate deployed code
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_MONITOR_SERVER modulefile {-operation update -contents %CD%\earfiles\observationmgr.jar -contenturi observationmgr.jar -deployejb}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

echo Update Action Manager application ...
call :logecho "Update Action Manager application ..."
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER file {-operation update -contents %CD%\earfiles\monAAMCatalog.jar -contenturi monAAMCatalog.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER file {-operation update -contents %CD%\earfiles\monAAMCommon.jar -contenturi monAAMCommon.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER file {-operation update -contents %CD%\earfiles\monAAMController.jar -contenturi monAAMController.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER file {-operation update -contents %CD%\earfiles\monAAMDetermination.jar -contenturi monAAMDetermination.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER file {-operation update -contents %CD%\earfiles\monAAMHandler.jar -contenturi monAAMHandler.jar}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
@rem use 'update <appName> modulefile' because we need to generate deployed code
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER modulefile {-operation update -contents %CD%\earfiles\monAAMMDB.jar -contenturi monAAMMDB.jar -deployejb}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
call "%WAS_PROFILE_HOME%\bin\wsadmin.bat" -conntype NONE -c "$AdminApp update IBM_WB_ACTIONMANAGER modulefile {-operation update -contents %CD%\earfiles\monAAMBootstrap.jar -contenturi monAAMBootstrap.jar -deployejb}" >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

@rem ************************************************************************
@rem update admin console plugins
@rem ************************************************************************
echo Update Admin Console ...
call :logecho "Update Admin Console ..."

REM extract the Monitor Server plugin
echo Extracting the Monitor Server Admin Console plugin...
call :logecho "Extracting the Monitor Server Admin Console plugin..."
CALL :manualISCDeploy .\files\monitor_admin_server.war com.ibm.ws.console.monitor.server wbimonitorserver >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

REM extract the Action Manager plugin
echo Extracting the Action Manager Admin Console plugin...
call :logecho "Extracting the Action Manager Admin Console plugin..."
CALL :manualISCDeploy .\files\monAAMAdmin.war com.ibm.ws.console.monitor.actionmgr actionmanager >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

REM extract the Schema Generator plugin
echo Extracting the Schema Generator Admin Console plugin...
call :logecho "Extracting the Schema Generator Admin Console plugin..."
CALL :manualISCDeploy .\files\monSGAdmin.war com.ibm.ws.console.monitor.schemagen SchemaGenerator >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed

REM execute iscdeploy to merge the plugin configuration files
echo Executing iscdeploy...
call :logecho "Executing iscdeploy..."
CALL "%WAS_HOME%\bin\iscdeploy.bat" -restore >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
echo End updating Admin Console plugins
call :logecho "End updating Admin Console plugins"

@rem ************************************************************************
@rem Restart the server
@rem ************************************************************************
echo Start server server1 ... 
call :logecho "Start server server1 ..."
call "%WAS_PROFILE_HOME%\bin\startServer" server1 >>%MY_LOG% 2>&1
if %errorlevel% NEQ 0 goto cmdFailed
GOTO end

@rem ************************************************************************
@rem **************** Begin function definitions ****************************
REM ----------------------------------------------------------------------
REM  manualISCDeploy
REM 
REM  Manually "deploy" a WCCM plugin to the administrative console's EAR. 
REM  You will need to execute "iscdeploy -restore" afterwards to complete
REM  the deployment.
REM 
REM  USAGE:
REM
REM    CALL :manualISCDeploy pluginWAR pluginId jarPrefix
REM 
REM      pluginWAR  Path the the plugin's WAR file
REM      pluginId   The plugin's Id
REM      jarPrefix  Prefix added to the plugin's jars when deployed.
REM 
REM    The WAS_HOME environment variable must be set prior to invocation.
REM ----------------------------------------------------------------------
:manualISCDeploy
SET PLUGIN_WAR=%~f1
SET PLUGIN_ID=%2
SET JAR_PREFIX=%3
SET ADMINCONSOLE_WAR="%WAS_HOME%\systemApps\adminconsole.ear\adminconsole.war"
SET JAR_EXE="%WAS_HOME%\java\bin\jar.exe"

ECHO Using the following settings:
ECHO.
ECHO   PLUGIN_WAR       = %PLUGIN_WAR%
ECHO   PLUGIN_ID        = %PLUGIN_ID%
ECHO   JAR_PREFIX       = %JAR_PREFIX%
ECHO.
ECHO   WAS_HOME         = %WAS_HOME%
ECHO   ADMINCONSOLE_WAR = %ADMINCONSOLE_WAR%
ECHO   JAR_EXE          = %JAR_EXE%
ECHO.

REM this script has to change directories to overcome limitations
REM in jar.exe, so I save the current directory name here
SET SAVE_CD=%CD%

REM change to the admin console's war directory
CD /D %ADMINCONSOLE_WAR%

REM extract NLS files
%JAR_EXE% xvf %PLUGIN_WAR% %PLUGIN_ID%
if %errorlevel% NEQ 0 goto :EOF

REM extract pre-compiled JSP files
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/classes
if %errorlevel% NEQ 0 goto :EOF

REM extract dependent jars to temp directory

REM create temp directory and change directory to it
SET TEMP_DIR=%TEMP%\monitor.server.install.%RANDOM%
MKDIR %TEMP_DIR%
CD /D %TEMP_DIR%

REM extract jars
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/lib
if %errorlevel% NEQ 0 goto :EOF

REM rename jars
CD WEB-INF\lib
SET JAR_LIST=jarlist.txt
FOR %%J IN (*.jar) DO ECHO %%J >> %JAR_LIST%
FOR /F %%J IN (%JAR_LIST%) DO RENAME %%J %JAR_PREFIX%-%%J
DEL %JAR_LIST%

REM move jars
MOVE * %ADMINCONSOLE_WAR%\WEB-INF\lib\
if %errorlevel% NEQ 0 goto :EOF

REM don't forget to cleanup temp directory

REM cd to plugin WEB-INF directory
SET PLUGIN_WEBINF_DIR=%ADMINCONSOLE_WAR%\WEB-INF\%PLUGIN_ID%
CD /D %PLUGIN_WEBINF_DIR%

REM extract needed files and move to the correct location
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/console-defs.xml
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin.dtd
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin.xml
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_de.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_en.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_es.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_fr.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_it.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_ja.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_ko.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_pt.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_pt_BR.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_zh.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/plugin_zh_TW.properties
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/struts-config.xml
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/validation.xml
if %errorlevel% NEQ 0 goto :EOF
REM MOVE  WEB-INF\* .  MOVE gives filename or extension too long error
COPY WEB-INF\* .
DEL /Q WEB-INF\*

REM add needed file to com.ibm.ws.consolse.core plugin
COPY console-defs.xml ..\com.ibm.ws.console.core\%PLUGIN_ID%-console-defs.xml
if %errorlevel% NEQ 0 goto :EOF

REM extract web.xml
%JAR_EXE% xvf %PLUGIN_WAR% WEB-INF/web.xml
if %errorlevel% NEQ 0 goto :EOF

REM restore original directory
CD /D %SAVE_CD%

REM cleanup temp files
RD /S/Q %TEMP_DIR%

REM return from manualISCDeploy
GOTO :EOF
REM ----------------------------------------------------------------------

REM ----------------------------------------------------------------------
REM  logecho
REM 
REM  write messages to log file
REM ----------------------------------------------------------------------
:logecho
echo ******************************************************** >> %MY_LOG% 2>&1
echo %~1 >> %MY_LOG% 2>&1
echo ******************************************************** >> %MY_LOG% 2>&1
time /t >>%MY_LOG% 2>&1
GOTO :EOF
REM ----------------------------------------------------------------------

@rem **************** End function definitions ******************************
@rem ************************************************************************

@rem ************************************************************************
:cmdFailed
@rem ************************************************************************
set SAVE_RC=%errorlevel%
echo Error: command failed, error code = %errorlevel%
call :logecho "Error: command failed, return code = %errorlevel%"
goto getout

@rem ************************************************************************
:getout
@rem ************************************************************************
echo Upgrade failed! 
echo Upgrade failed! >>%MY_LOG% 2>&1
goto end2

@rem ************************************************************************
:end
@rem ************************************************************************
echo Upgrade finished.
echo Upgrade finished. >>%MY_LOG% 2>&1
:end2
time /t >>%MY_LOG% 2>&1
exit /b %SAVE_RC%

